﻿using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.ComponentModel;
using System.Linq;
using System.Runtime.Remoting;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using Syncfusion.Windows.Diagram;

namespace PortRestriction
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();
            View.ConnectorDragEnd += View_ConnectorDragEnd;
            Node n = AddNode(100, 100, 100, 100);
            Node n1 = AddNode(300, 100, 100, 100);
            Model.Nodes.Add(n);
            Model.Nodes.Add(n1);
        }
       
        private Node AddNode(double x, double y, double width, double height)
        {
            Node n = new Node()
            {
                Width = width,
                Height = height,
                OffsetX = x,
                OffsetY = y,
                Shape = Shapes.Rectangle,
            };
            n.Ports = new ObservableCollection<ConnectionPort>()
            {
                new CustomPort()
                {
                    IsConnected = false,
                    Top = 20,
                    Left = 20,
                    Node = n
                }
            };
            return n;
        }

        private CustomPort oldpPort;

        private void View_ConnectorDragEnd(object sender, ConnDragEndRoutedEventArgs evtArgs)
        {
             LineConnector line = (evtArgs.Connector as LineConnector);
            if (evtArgs.HitNodeEnd!=null)
            {
                if (line.HeadNode != null && line.ConnectionHeadPort != null)
                {
                    if (line.HeadNode==evtArgs.HitNodeEnd)
                    {
                        if ((line.ConnectionHeadPort as CustomPort).IsConnected || line.ConnectionHeadPort.Node!=evtArgs.HitNodeEnd)
                        {
                            line.ConnectionHeadPort = null;
                            line.HeadNode = null;
                        }
                        else
                        {
                            oldpPort = (line.ConnectionHeadPort as CustomPort);
                            (line.ConnectionHeadPort as CustomPort).IsConnected = true;
                        } 
                    }
                    else
                    {
                        (line.ConnectionHeadPort as CustomPort).IsConnected = false;
                    }
                }
                else if (line.TailNode != null && line.ConnectionTailPort != null)
                {
                    if (line.TailNode==evtArgs.HitNodeEnd)
                    {
                        if ((line.ConnectionTailPort as CustomPort).IsConnected || line.ConnectionTailPort.Node != evtArgs.HitNodeEnd)
                        {
                            line.ConnectionTailPort = null;
                            line.TailNode = null;
                        }
                        else
                        {
                            oldpPort = (line.ConnectionHeadPort as CustomPort);
                            (line.ConnectionTailPort as CustomPort).IsConnected = true;
                        } 
                    }
                    else
                    {
                        (line.ConnectionTailPort as CustomPort).IsConnected = false;
                    }
                } 
            }
            else
            {
                oldpPort.IsConnected = false;
            }
        }
    }

    public class CustomPort : ConnectionPort
    {
        private bool _isConnected;

        public bool IsConnected
        {
            get { return _isConnected; }
            set { _isConnected = value; }
        }
    }
}
